// Using associative tables is the recommended way of representing many-to-many relationships.
//https://en.wikipedia.org/wiki/Many-to-many_%28data_model%29
//http://web.csulb.edu/colleges/coe/cecs/dbdesign/dbdesign.php?page=manymany.php

exports.up = function (knex, Promise) {
    return knex.schema.createTable('simple_meta_memberships', function (table) {
        table.string('simplegroup_gid', 128).notNullable()
            .references('gid').inTable('simplegroups')
            .onDelete('CASCADE'); //delete row from memberships if member is deleted
        table.string('metagroup_gid', 128).notNullable()
            .references('gid').inTable('metagroups')
            .onDelete('CASCADE'); //delete row from memberships if container is deleted
    });
};

exports.down = function (knex, Promise) {
    return knex.schema.dropTable('simple_meta_memberships');
};
