
exports.up = function (knex, Promise) {
    return knex.schema.createTable('messages_privateposts', function (table) {
        table.integer('mid').primary().notNullable() //(non-nullable) primary key
            .references('mid').inTable('messages')
            .onDelete('CASCADE'); 
        table.timestamps(true, true); //adds timestamptz-type (a PostgresQL data type) updated_at and created_at columns

        table.string('title').notNullable();
        table.text('content').notNullable();

        table.string('recipient', 128)
            .references('gid').inTable('groups')
            .onDelete('CASCADE'); //if recipient is deleted, also delete the private post (don't direct to noone to avoid spamming it, + supposed to be private)
        table.string('author')
            .references('uid').inTable('users')
            .onDelete('SET NULL'); //must refer to a User's uid.

        table.integer('parent')
            .references('mid').inTable('messages_privateposts')
            .onDelete('SET NULL');
    });
};

exports.down = function (knex, Promise) {
    return knex.schema.dropTable('messages_privateposts');
};
