
exports.up = function (knex, Promise) {
    return knex.schema.createTable('requests_user_join_group', function (table) {
        table.integer('rid').primary().notNullable() //(non-nullable) primary key
            .references('rid').inTable('requests')
            .onDelete('CASCADE');
        table.timestamps(true, true); //adds timestamptz-type (a PostgresQL data type) updated_at and created_at columns

        table.text('comment');
        table.string('from').notNullable()
            .references('uid').inTable('users')
            .onDelete('CASCADE'); //must refer to a User's uid.
        table.string('to', 128).notNullable()
            .references('gid').inTable('simplegroups')
            .onDelete('CASCADE'); //delete request from database if recipient group is deleted
    });
};

exports.down = function (knex, Promise) {
    return knex.schema.dropTable('requests_user_join_group');
};
